#include "standard.h"
#include "mcfold.h"

void MouseclickFolder::register_mouseclick(Hand* hand,int b,callback cb)
  {
  if (b==LEFTMOUSEBUTTON)
    leftbuttonlist.add(hand,cb);
  else
    rightbuttonlist.add(hand,cb);
  }

void MouseclickFolder::unregister_mouseclick(Hand* hand,int b,callback cb)
  {
  if (b==LEFTMOUSEBUTTON)
    leftbuttonlist.del(hand,cb);
  else
    rightbuttonlist.del(hand,cb);
  }

void MouseclickFolder::delHand(Hand* h)
  {
  leftbuttonlist.delHand(h);
  rightbuttonlist.delHand(h);
  }

void MouseclickFolder::reset()
  {
  leftbuttonlist.reset();
  rightbuttonlist.reset();
  }

void MouseclickFolder::dispatch(int x, int y, int button)
  {
  if (button == LEFTMOUSEBUTTON)
    leftbuttonlist.execute_callbacks(x,y,LEFTMOUSEBUTTON);
  else
    rightbuttonlist.execute_callbacks(x,y,RIGHTMOUSEBUTTON);
  }
